Unit DE49R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE48R_p, UTDE16_p;

procedure DE49R(F :Proc_F_DE; M :Integer; XN :Real;
                var YN :Array of Real; var DYN :Array of Real;
                XK :Real; HMIN :Real; HMAX :Real;
                EPS :Real; P :Real; var H :Real;
                var Y :Array of Real; var DY :Array of Real;
                var DELTY :Array of Real; var DF :Array of Real;
                var RFN :Array of Real; var RF :Array of Real;
                var YP :Array of Real; var DYP :Array of Real;
                var IERR :Integer);

implementation

procedure DE49R(F :Proc_F_DE; M :Integer; XN :Real;
                var YN :Array of Real; var DYN :Array of Real;
                XK :Real; HMIN :Real; HMAX :Real;
                EPS :Real; P :Real; var H :Real;
                var Y :Array of Real; var DY :Array of Real;
                var DELTY :Array of Real; var DF :Array of Real;
                var RFN :Array of Real; var RF :Array of Real;
                var YP :Array of Real; var DYP :Array of Real;
                var IERR :Integer);
var
I,JSTART :Integer;
H1,HS,X :Real;
BUL :Boolean;
label
_10,_20,_30,_40,_50,_60;
begin
IERR := 0;
for I:=1 to M do
 begin
  DY[I-1] := DYN[I-1];
  Y[I-1] := YN[I-1];
_10:
 end;
if ( XN =  XK ) 
 then goto _60;
X := XN;
H := Sign(H,XK-XN);
BUL := False;
_20:
JSTART := 0;
_30:
if ( not  BUL ) 
 then goto _40;
H := HS;
goto _60;
_40:
H1 := XK - X;
if ( Abs(H1) >  Abs(H) ) 
 then goto _50;
HS := H;
H := H1;
BUL := True;
_50:
DE48R(F,M,JSTART,HMIN,HMAX,EPS,P,Y,X,DY,H,BUL,DELTY,DF,
     RFN,RF,YP,DYP,IERR);
if ( IERR =  0 ) 
 then goto _30;
UTDE16(IERR,49);
_60:
end;

end.
